/////////////////////////
//   
/////////////////////////

extern string _1. = "  ";

extern double BuyLots = 0.1; //  .

extern double SellLots = 0.1; //  .

extern int MartingaleStep = 200; //    .

extern int BuyProfitPips = 250; //  ().

extern int SellProfitPips = 250; //  ().

extern int FixingMethod = 1; //    (1,2).

extern double Progression = 1.5; //  .

extern double Progression_Filter = 1.5; //  .

extern string _2. = "  ";

extern bool Fractal = false; //   Fractal.

extern int Fractal_Timeframe = 0; //   Fractal.

extern int Fractal_Period = 20; //     Fractal.

extern string _3. = " ";

extern bool Filter_MA = true; //    MA.

extern int Filter_MA_Timeframe = 0; //  MA .

extern int Filter_MA_Period = 200; //  MA .

extern bool Filter_RSI = true; //    RSI.

extern int Filter_RSI_Timeframe = 0; //  RSI .

extern int Filter_RSI_Period = 10; //  RSI .

extern string _4. = " MAGIC ";

extern int Magic_Master = 20070301; // 1- MAGIC .

extern int Magic_Slave = 20070302; // 2- MAGIC .

extern string _5. = " ";

extern bool Comments = false; //  .

/////////////////////////
// 
/////////////////////////

int i, NumBuys, NumSells;
double OpenBuyLots, OpenSellLots, OpenBuyProfit, OpenSellProfit, HighFractal, LowFractal, HighestBuy, LowestBuy, LowestSell, HighestSell, StartLowestBuy, StartHighestSell;
double Filter_MA_Point, Filter_RSI_Point, BuyLevelMartingale, NextBuyLevelMartingale, SellLevelMartingale, NextSellLevelMartingale, ReqBuyLots, ReqSellLots, NextStartBuyLots, NextStartSellLots;
bool BuySignal, SellSignal, FilterBlockBuy, FilterBlockSell, EntryToBuy, EntryToSell, BlockBuy, BlockSell;
int type_clr,err_clr;
double price_clr;
bool result_clr;
double MaxDrawDown, MaxEquity;
double AccountStart;
string OrderCommentString, DateStart;

/////////////////////////
//     
/////////////////////////
int init()
{
if (IsTesting() == true)
{
AccountStart=AccountEquity();
DateStart=TimeToStr(TimeCurrent(),TIME_DATE);
}
}

int deinit()
{
Print(" ",DateStart,"-",TimeToStr(TimeCurrent(),TIME_DATE)," |  =",AccountEquity()-AccountStart," |  =",MathAbs(MaxDrawDown),
" | : BuyLots=",BuyLots,"; SellLots=",SellLots,"; MartingaleStep=",MartingaleStep,
"; BuyProfitPips=",BuyProfitPips,"; SellProfitPips=",SellProfitPips,"; FixingMethod=",FixingMethod,
"; Progression=",Progression,"; Progression_Filter=",Progression_Filter,"; Fractal=",Fractal,
"; Fractal_Timeframe=",Fractal_Timeframe,"; Fractal_Period=",Fractal_Period,
"; Filter_MA=",Filter_MA,"; Filter_MA_Timeframe=",Filter_MA_Timeframe,"; Filter_MA_Period=",Filter_MA_Period,
"; Filter_RSI=",Filter_RSI,"; Filter_RSI_Timeframe=",Filter_RSI_Timeframe,"; Filter_RSI_Period=",Filter_RSI_Period);
return(0);
}

int start()
{

/////////////////////////
//      
/////////////////////////

NumBuys = 0;
NumSells = 0;
OpenBuyLots = 0;
OpenSellLots = 0;
OpenBuyProfit = 0;
OpenSellProfit = 0;
HighestBuy = 0;
LowestBuy = 10000;
HighestSell = 0;
LowestSell = 10000;
StartLowestBuy = 10000;
StartHighestSell = 0;

for(i = 0; i < OrdersTotal(); i++)
{
OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
if (OrderSymbol() == Symbol() && (OrderMagicNumber() == Magic_Slave || OrderMagicNumber() == Magic_Master))
{
if (OrderType() == OP_BUY)
{
NumBuys++;
OpenBuyLots = OpenBuyLots + OrderLots();
OpenBuyProfit = OpenBuyProfit + OrderProfit()-OrderSwap(); //  
if (OrderOpenPrice() > HighestBuy) HighestBuy = OrderOpenPrice();
if (OrderOpenPrice() < LowestBuy) LowestBuy = OrderOpenPrice();
}
if (OrderType() == OP_SELL)
{
NumSells++;
OpenSellLots = OpenSellLots + OrderLots();
OpenSellProfit = OpenSellProfit + OrderProfit()-OrderSwap(); //  
if (OrderOpenPrice() < LowestSell) LowestSell = OrderOpenPrice();
if (OrderOpenPrice() > HighestSell) HighestSell = OrderOpenPrice();
}
}
if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_Master)
{
if (OrderType() == OP_BUY)
{
if (OrderOpenPrice() < StartLowestBuy) StartLowestBuy = OrderOpenPrice();
}
if (OrderType() == OP_SELL)
{
if (OrderOpenPrice() > StartHighestSell) StartHighestSell = OrderOpenPrice();
}
}
}

/////////////////////////
//   Buy/Sell
/////////////////////////
if (Fractal == false)
{
BuySignal = true;
SellSignal = true;
}
else
{
BuySignal = false;
SellSignal = false;
}

//       ( Fractal)
if (BuySignal == false)
{
HighFractal = High[iHighest(NULL,Fractal_Timeframe,MODE_HIGH,Fractal_Period,1)]; //  "1",  
if (HighFractal < Open[0]) BuySignal=true; //    "Bid-5*Point"
}

if (SellSignal == false)
{
LowFractal = Low[iLowest(NULL,Fractal_Timeframe,MODE_HIGH,Fractal_Period,1)]; //  "1",  
if (LowFractal > Open[0]) SellSignal=true; //    "Bid+5*Point"
}
//       ( Fractal)

/////////////////////////
//   Buy/Sell
/////////////////////////
EntryToBuy = false;
EntryToSell = false;

if (Filter_MA == true)
{
Filter_MA_Point = NormalizeDouble(iMA(NULL,Filter_MA_Timeframe,Filter_MA_Period,0,MODE_SMMA,PRICE_CLOSE,1),4);
}
if (Filter_RSI == true)
{
Filter_RSI_Point = NormalizeDouble(iRSI(NULL,Filter_RSI_Timeframe,Filter_RSI_Period,PRICE_CLOSE,0),0);
}

//   
if ((Filter_MA == true && Filter_RSI == true && Bid > Filter_MA_Point && Filter_RSI_Point < 30) ||
(Filter_MA == true && Filter_RSI == false && Bid > Filter_MA_Point) ||
(Filter_MA == false && Filter_RSI == true && Filter_RSI_Point < 30))
{
if (FilterBlockBuy == true &&
NumBuys > 0 &&
LowestBuy != 10000 &&
(LowestBuy-Bid)/Point > MartingaleStep &&
(StartLowestBuy > Bid && StartLowestBuy-MartingaleStep*Point >= Bid)) //  
{
EntryToBuy=true;
}
FilterBlockSell=true;
FilterBlockBuy=false;
}
else FilterBlockBuy=true;

//   
if ((Filter_MA == true && Filter_RSI == true && Bid < Filter_MA_Point && Filter_RSI_Point > 70) ||
(Filter_MA == true && Filter_RSI == false && Bid < Filter_MA_Point) ||
(Filter_MA == false && Filter_RSI == true && Filter_RSI_Point > 70))
{
if (FilterBlockSell == true &&
NumSells > 0 &&
HighestSell > 0 &&
(Bid-HighestSell)/Point > MartingaleStep &&
StartHighestSell+MartingaleStep*Point <= Bid) //  
{
EntryToSell=true;
}
FilterBlockBuy=true;
FilterBlockSell=false;
}
else FilterBlockSell=true;

//  
if (Filter_MA == false && Filter_RSI == false)
{
if (FilterBlockBuy == true &&
NumBuys > 0 &&
LowestBuy != 10000 &&
(LowestBuy-Bid)/Point > MartingaleStep &&
(StartLowestBuy > Bid && StartLowestBuy-MartingaleStep*Point >= Bid)) //  
{
EntryToBuy=true;
}
FilterBlockBuy=false;

if (FilterBlockSell == true &&
NumSells > 0 &&
HighestSell > 0 &&
(Bid-HighestSell)/Point > MartingaleStep &&
StartHighestSell+MartingaleStep*Point <= Bid) //  
{
EntryToSell=true;
}
FilterBlockSell=false;
}

/////////////////////////
//     
/////////////////////////
if (Period() == 1) OrderCommentString="M1 - ";
if (Period() == 5) OrderCommentString="M5 - ";
if (Period() == 15) OrderCommentString="M15 - ";
if (Period() == 30) OrderCommentString="M30 - ";
if (Period() == 60) OrderCommentString="H1 - ";
if (Period() == 240) OrderCommentString="H4 - ";
if (Period() == 1440) OrderCommentString="D1 - ";
if (Period() == 10080) OrderCommentString="W1 - ";
if (Period() == 43200) OrderCommentString="MN1 - ";

/////////////////////////
//    
/////////////////////////
if (BuySignal == true && FilterBlockBuy == false && NumBuys == 0)
{
OrderSend(Symbol(),OP_BUY,BuyLots,Ask,100,0,0,OrderCommentString+Magic_Master,Magic_Master,0,Blue);
NumBuys++;
}

if (SellSignal == true && FilterBlockSell == false && NumSells == 0)
{
OrderSend(Symbol(),OP_SELL,SellLots,Bid,100,0,0,OrderCommentString+Magic_Master,Magic_Master,0,Red);
NumSells++;
}

/////////////////////////
//       
/////////////////////////

BuyLevelMartingale = 0;
NextBuyLevelMartingale = 0;
ReqBuyLots = 0;
SellLevelMartingale = 0;
ReqSellLots = 0;
NextSellLevelMartingale = 0;

if (HighestBuy > Bid && NumBuys > 0)
{
BuyLevelMartingale = (HighestBuy - Bid) / Point / MartingaleStep; //  
NextBuyLevelMartingale = (StartLowestBuy - Bid) / Point / MartingaleStep; //   
ReqBuyLots = NormalizeDouble((MathPow(Progression,NextBuyLevelMartingale)*2-1)*BuyLots,1); //   ()
}

if (LowestSell < Bid && NumSells > 0)
{
SellLevelMartingale = (Bid - LowestSell) / Point / MartingaleStep; //   
NextSellLevelMartingale = (Bid - StartHighestSell) / Point / MartingaleStep; //   
ReqSellLots = NormalizeDouble((MathPow(Progression,NextSellLevelMartingale)*2-1)*SellLots,1); //   ()
}

NextStartBuyLots = NormalizeDouble(MathAbs(OpenBuyProfit)/MartingaleStep/10*(Progression_Filter-1),1);//   10   -.
NextStartSellLots = NormalizeDouble(MathAbs(OpenSellProfit)/MartingaleStep/10*(Progression_Filter-1),1);//   10   -.

/////////////////////////
//     (  
/////////////////////////
if (EntryToBuy == true && NextStartBuyLots >= MarketInfo(Symbol(),MODE_MINLOT))
{
OrderSend(Symbol(),OP_BUY,NextStartBuyLots,Ask,100,0,0,OrderCommentString+Magic_Master,Magic_Master,0,LightSkyBlue);
}

if (EntryToSell == true && NextStartSellLots >= MarketInfo(Symbol(),MODE_MINLOT))
{
OrderSend(Symbol(),OP_SELL,NextStartSellLots,Bid,100,0,0,OrderCommentString+Magic_Master,Magic_Master,0,Pink);
}

/////////////////////////
//  
/////////////////////////

if (ReqBuyLots > OpenBuyLots && NumBuys > 0 && FilterBlockBuy == false && EntryToBuy == false && ReqBuyLots-OpenBuyLots >= MarketInfo(Symbol(),MODE_MINLOT))
{
OrderSend(Symbol(),OP_BUY,ReqBuyLots-OpenBuyLots,Ask,100,0,0,OrderCommentString+Magic_Slave,Magic_Slave,0,DodgerBlue);
NumBuys++;
}

if (ReqSellLots > OpenSellLots && NumSells > 0 && FilterBlockSell == false && EntryToSell == false && ReqSellLots-OpenSellLots >= MarketInfo(Symbol(),MODE_MINLOT))
{
OrderSend(Symbol(),OP_SELL,ReqSellLots-OpenSellLots,Bid,100,0,0,OrderCommentString+Magic_Slave,Magic_Slave,0,Tomato);
NumSells++;
}

/////////////////////////
//  
/////////////////////////

if ((FixingMethod == 2 && OpenBuyProfit > BuyProfitPips*OpenBuyLots*10) || //   10   -.
(FixingMethod == 1 && LowestBuy+BuyProfitPips*Point < Bid))
{
for(i=OrdersTotal()-1;i>=0;i--)
{
if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
{
if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_Slave || OrderMagicNumber() == Magic_Master)
{
type_clr=OrderType();
if(type_clr==OP_BUY)
{
while(true)
{
if(type_clr==OP_BUY) price_clr=MarketInfo(OrderSymbol(),MODE_BID);
result_clr=OrderClose(OrderTicket(),OrderLots(),price_clr,100,Gold);
if(result_clr!=true) {err_clr=GetLastError(); Print("LastError = ",err_clr);}
else err_clr=0;
if(err_clr==135) RefreshRates();
else break;
}
}
}
}
}
}

if ((FixingMethod == 2 && OpenSellProfit > SellProfitPips*OpenSellLots*10) || //   10   -.
(FixingMethod == 1 && HighestSell-SellProfitPips*Point > Bid))
{
for(i=OrdersTotal()-1;i>=0;i--)
{
if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
{
if (OrderSymbol() == Symbol() && (OrderMagicNumber() == Magic_Slave || OrderMagicNumber() == Magic_Master))
{
type_clr=OrderType();
if(type_clr==OP_SELL)
{
while(true)
{
if(type_clr==OP_SELL) price_clr=MarketInfo(OrderSymbol(),MODE_ASK);
result_clr=OrderClose(OrderTicket(),OrderLots(),price_clr,100,Gold);
if(result_clr!=true) {err_clr=GetLastError(); Print("LastError = ",err_clr);}
else err_clr=0;
if(err_clr==135) RefreshRates();
else break;
}
}
}
}
}
}

/////////////////////////
//  
/////////////////////////
if (MaxEquity < AccountEquity()) { MaxEquity = AccountEquity(); }
if (MaxDrawDown > (AccountEquity()-MaxEquity)) { MaxDrawDown = AccountEquity()-MaxEquity; }
if (Comments == true)
{
Comment("\nHighFractal = ",HighFractal,", LowFractal = ",LowFractal,", BuySignal = ",BuySignal,", SellSignal = ",SellSignal,
"\nNumBuys = ",NumBuys,", NumSells = ",NumSells,", OpenBuyLots = ",OpenBuyLots,", OpenSellLots = ",OpenSellLots,", OpenBuyProfit = ",OpenBuyProfit,", OpenSellProfit = ",OpenSellProfit,
"\nHighestBuy = ",HighestBuy,", LowestBuy = ",LowestBuy,", HighestSell = ",HighestSell,", LowestSell = ",LowestSell, ", StartLowestBuy = ",StartLowestBuy,", StartHighestSell = ",StartHighestSell,
"\nFilter_RSI_Point = ",Filter_RSI_Point,
"\nBuyLevelMartingale = ",BuyLevelMartingale,", NextBuyLevelMartingale = ",NextBuyLevelMartingale,",ReqBuyLots = ",ReqBuyLots,", SellLevelMartingale = ",SellLevelMartingale,", NextSellLevelMartingale = ",NextSellLevelMartingale,",ReqSellLots = ",ReqSellLots,
"\nNextStartBuyLots = ",NextStartBuyLots,", NextStartSellLots = ",NextStartSellLots,", EntryToBuy = ",EntryToBuy,", EntryToSell = ",EntryToSell,", FilterBlockBuy = ",FilterBlockBuy,", FilterBlockSell = ",FilterBlockSell,
"\nMaxDrawDown = ",MaxDrawDown);
}
return(0);
}

